// Copyright (c) 2003-2016  Pavel Rychly, Milos Jakubicek

#ifndef CONSUMER_HH
#define CONSUMER_HH

#include <finlib/fstream.hh>
#include <string>

class TextConsumer {
protected:
    TextConsumer() {}
public:
    virtual ~TextConsumer() {}
    void operator() (int id) {this->put (id);}
    virtual void put (int id) =0;
    virtual Position curr_size() =0;
    typedef enum {tdelta, tdeltabig, tint, tdeltagiga} TextType;
    virtual TextType get_type() {return type;}
    static TextConsumer* create (TextType tt, const std::string &path, 
                                 bool append=false);
private:
    TextType type;
};


class RevFileConsumer {
protected:
    RevFileConsumer() {}
public:
    virtual ~RevFileConsumer() {}
    void operator() (int id, Position pos) {this->put (id, pos);}
    virtual void put (int id, Position pos) =0;

    static RevFileConsumer* create (const std::string &path, 
                                    int buff_size=1048576, int align=1,
                                    bool append=false, bool part_sort=false);
};


void finish_rev_files (const std::string &outname, int num_of_files, 
                       int align, bool part_sort=false);

#endif

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
